<template>
  <div class="app-container">
    <div class="container">
      <el-form :model="queryParams"
        ref="queryRef"
        :inline="true"
        label-width="68px">

        <el-form-item label="用户名称"
          prop="nickName">
          <el-input v-model="queryParams.nickName"
            placeholder="请输入用户名称"
            clearable
            style="width: 240px" />
        </el-form-item>
        <el-form-item label="用户工号"
          prop="userName">
          <el-input v-model="queryParams.userName"
            placeholder="请输入用户工号"
            clearable
            style="width: 240px" />
        </el-form-item>
        <el-form-item label="手机号码"
          prop="phonenumber">
          <el-input v-model="queryParams.phonenumber"
            placeholder="请输入手机号码"
            clearable
            style="width: 240px" />
        </el-form-item>
        <el-form-item>
          <el-button icon="Refresh"
            @click="resetQuery">重置</el-button>
        </el-form-item>
      </el-form>

      <!-- 表格数据 -->
      <el-table v-loading="loading"
        :data="userList">
        <el-table-column type="selection"
          width="50" />
        <el-table-column label="用户工号"
          key="userName"
          prop="userName"
          align="left" />
        <el-table-column label="用户昵称"
          key="nickName"
          prop="nickName"
          align="left" />
        <el-table-column label="手机号码"
          key="phonenumber"
          prop="phonenumber"
          align="left" />
        <el-table-column label="创建时间"
          prop="createTime"
          align="left">
          <template #default="scope">
            <span>{{ parseTime(scope.row.createTime) }}</span>
          </template>
        </el-table-column>
        <el-table-column label="分配报表"
          class-name="small-padding fixed-width"
          align="left">
          <template #default="scope">
            <xl-tool-tip content="分配报表"
              placement="top"
              v-if="scope.row.userId !== 1">
              <el-button link
                type="primary"
                icon="Reading"
                @click="handleAuthRole(scope.row)"></el-button>
            </xl-tool-tip>
          </template>
        </el-table-column>
      </el-table>

      <pagination v-show="total > 0"
        :total="total"
        v-model:page="queryParams.pageNum"
        v-model:limit="queryParams.pageSize"
        @pagination="getList" />

      <!-- 分配用户 -->
      <el-dialog title="选择用户"
        v-model="showSelUser"
        top="5vh"
        append-to-body
        draggable
        overflow>
        <el-form :model="queryParams"
          ref="queryRef"
          :inline="true">
          <el-form-item label="部门选择"
            prop="roleName">
            <el-tree-select v-model="queryParams.deptId"
              :data="deptOptions"
              filterable
              highlight-current
              node-key="id"
              check-strictly
              :default-expanded-keys="defaultExpandedKeys"
              style="width: 240px" />
          </el-form-item>
          <el-form-item label="用户工号"
            prop="userName">
            <el-input v-model="queryParams.userName"
              placeholder="请输入用户工号"
              clearable
              style="width: 180px"
              @input="handleQuery" />
          </el-form-item>
          <el-form-item label="用户昵称"
            prop="nickName">
            <el-input v-model="queryParams.nickName"
              placeholder="请输入用户昵称"
              clearable
              style="width: 180px"
              @input="handleQuery" />
          </el-form-item>
          <el-form-item label="手机号码"
            prop="phonenumber">
            <el-input v-model="queryParams.phonenumber"
              placeholder="请输入手机号码"
              clearable
              style="width: 180px"
              @input="handleQuery" />
          </el-form-item>
          <el-form-item>
            <el-button icon="Refresh"
              @click="resetQuery">重置</el-button>
          </el-form-item>
        </el-form>
        <el-row>
          <el-table @row-click="clickRow"
            ref="refTable"
            :data="userList"
            @selection-change="handleSelectionChange">
            <el-table-column type="selection"
              width="55"></el-table-column>
            <el-table-column label="用户工号"
              prop="userName"
              :show-overflow-tooltip="true" />
            <el-table-column label="用户昵称"
              prop="nickName"
              :show-overflow-tooltip="true" />
            <el-table-column label="邮箱"
              prop="email"
              :show-overflow-tooltip="true" />
            <el-table-column label="手机"
              prop="phonenumber"
              :show-overflow-tooltip="true" />
            <el-table-column label="状态"
              align="center"
              prop="status">
              <template #default="scope">
                <dict-tag :options="sys_normal_disable"
                  :value="scope.row.status" />
              </template>
            </el-table-column>
            <el-table-column label="创建时间"
              align="center"
              prop="createTime"
              width="180">
              <template #default="scope">
                <span>{{ parseTime(scope.row.createTime) }}</span>
              </template>
            </el-table-column>
          </el-table>
          <div class="pagination-wrap">
            <pagination v-show="total > 0"
              :total="total"
              v-model:page="queryParams.pageNum"
              v-model:limit="queryParams.pageSize"
              @pagination="getList" />
          </div>
        </el-row>
        <template #footer>
          <div class="dialog-footer">
            <el-button type="primary"
              @click="handleSelectUser">确 定</el-button>
            <el-button @click="visible = false">取 消</el-button>
          </div>
        </template>
      </el-dialog>
    </div>
  </div>
</template>

<script setup
  name="Role">
  import { addRole, changeRoleStatus, dataScope, delRole, getRole, listRole, updateRole, deptTreeSelect } from "@/api";
  import { deptTreeSelectList, listUser, getReportFolderListAPI, roleMenuTreeselect, treeselect as menuTreeselect } from "@/api";

  const router = useRouter();
  const { proxy } = getCurrentInstance();
  const { sys_normal_disable } = proxy.useDict("sys_normal_disable");

  const roleList = ref([]);
  const open = ref(false);
  const loading = ref(true);
  const showSearch = ref(true);
  const ids = ref([]);
  const single = ref(true);
  const multiple = ref(true);

  const title = ref("");
  const dateRange = ref([]);
  const menuOptions = ref([]);
  const menuExpand = ref(false);
  const menuNodeAll = ref(false);
  const deptExpand = ref(true);
  const deptNodeAll = ref(false);

  const menuRef = ref(null);


  // 部门查询
  const deptRef = ref(null)
  const deptOptions = ref([]); // 部门树结构
  const defaultExpandedKeys = ref([]) // 默认展开 id
  function getDeptList() {
    loading.value = true;
    deptTreeSelectList().then(response => {
      deptOptions.value = response.data;
      defaultExpandedKeys.value = [response.data[0].id];
    });
  }
  getDeptList()

  /** 查询用户列表 */
  const showSelUser = ref(false)
  const userList = ref([])
  const total = ref(0);
  function getUserList() {
    loading.value = true;
    listUser().then(res => {
      console.log('用户', res)
      loading.value = false;
      userList.value = res.data.rows;
      total.value = res.data.total;
    })
  }
  getUserList()

  // 分配报表
  function handleAuthRole(row) {
    console.log('分配报表', row)
    showSelUser.value = true;
  }

  // 获取积木报表列表
  const reportFolderList = ref([])
  function getReportFolderList() {
    getReportFolderListAPI().then(res => {
      console.log('报表', res)
      reportFolderList.value = res.data;
    })
  }
  getReportFolderList()

  /** 数据范围选项*/
  const dataScopeOptions = ref([
    { value: "1", label: "全部数据权限" },
    { value: "2", label: "自定数据权限" },
    { value: "3", label: "本部门数据权限" },
    { value: "4", label: "本部门及以下数据权限" },
    { value: "5", label: "仅本人数据权限" }
  ]);

  const data = reactive({
    form: {},
    queryParams: {
      pageNum: 1,
      pageSize: 10,
      roleName: undefined,
      roleKey: undefined,
      status: undefined,

      deptId: undefined,
      nickName: undefined
    },
    rules: {
      roleName: [{ required: true, message: "角色名称不能为空", trigger: "blur" }],
      roleKey: [{ required: true, message: "权限字符不能为空", trigger: "blur" }],
      roleSort: [{ required: true, message: "角色顺序不能为空", trigger: "blur" }]
    },
  });

  const { queryParams, form, rules } = toRefs(data);

  /** 查询角色列表 */
  function getList() {
    loading.value = true;
    listRole(proxy.addDateRange(queryParams.value, dateRange.value)).then(response => {
      roleList.value = response.data.rows;
      total.value = response.data.total;
      loading.value = false;
    });
  }

  /** 搜索按钮操作 */
  function handleQuery() {
    queryParams.value.pageNum = 1;
    getList();
  }

  /** 重置按钮操作 */
  function resetQuery() {
    dateRange.value = [];
    proxy.resetForm("queryRef");
    handleQuery();
  }

  /** 删除按钮操作 */
  function handleDelete(row) {
    const roleIds = row.roleId || ids.value;
    proxy.$modal.confirm('是否确认删除角色编号为"' + roleIds + '"的数据项?').then(function () {
      return delRole(roleIds);
    }).then(() => {
      getList();
      proxy.$modal.msgSuccess("删除成功");
    }).catch(() => { });
  }

  /** 导出按钮操作 */
  function handleExport() {
    proxy.download("system/role/export", {
      ...queryParams.value,
    }, `role_${new Date().getTime()}.xlsx`);
  }

  /** 多选框选中数据 */
  function handleSelectionChange(selection) {
    ids.value = selection.map(item => item.roleId);
    single.value = selection.length != 1;
    multiple.value = !selection.length;
  }

  /** 角色状态修改 */
  function handleStatusChange(row) {
    let text = row.status === "0" ? "启用" : "停用";
    proxy.$modal.confirm('确认要"' + text + '""' + row.roleName + '"角色吗?').then(function () {
      return changeRoleStatus(row.roleId, row.status);
    }).then(() => {
      proxy.$modal.msgSuccess(text + "成功");
    }).catch(function () {
      row.status = row.status === "0" ? "1" : "0";
    });
  }

  /** 更多操作 */
  function handleCommand(command, row) {
    switch (command) {
      case "handleDataScope":
        handleDataScope(row);
        break;
      case "handleAuthUser":
        handleAuthUser(row);
        break;
      default:
        break;
    }
  }

  /** 分配用户 */
  function handleAuthUser(row) {
    router.push("/system/role-auth/user/" + row.roleId);
  }

  /** 查询菜单树结构 */
  function getMenuTreeselect() {
    menuTreeselect().then(response => {
      menuOptions.value = response.data;
    });
  }

  /** 所有部门节点数据 */
  function getDeptAllCheckedKeys() {
    // 目前被选中的部门节点
    let checkedKeys = deptRef.value.getCheckedKeys();
    // 半选中的部门节点
    let halfCheckedKeys = deptRef.value.getHalfCheckedKeys();
    checkedKeys.unshift.apply(checkedKeys, halfCheckedKeys);
    return checkedKeys;
  }

  /** 重置新增的表单以及其他数据  */
  function reset() {
    if (menuRef.value != undefined) {
      menuRef.value.setCheckedKeys([]);
    }
    menuExpand.value = false;
    menuNodeAll.value = false;
    deptExpand.value = true;
    deptNodeAll.value = false;
    form.value = {
      roleId: undefined,
      roleName: undefined,
      roleKey: undefined,
      roleSort: 0,
      status: "0",
      menuIds: [],
      deptIds: [],
      menuCheckStrictly: true,
      deptCheckStrictly: true,
      remark: undefined
    };
    proxy.resetForm("roleRef");
  }

  /** 添加角色 */
  function handleAdd() {
    reset();
    getMenuTreeselect();
    open.value = true;
    title.value = "添加角色";
  }

  /** 修改角色 */
  function handleUpdate(row) {
    reset();
    const roleId = row.roleId || ids.value;
    const roleMenu = getRoleMenuTreeselect(roleId);
    getRole(roleId).then(response => {
      form.value = response.data;
      form.value.roleSort = Number(form.value.roleSort);
      open.value = true;
      nextTick(() => {
        roleMenu.then((res) => {
          let checkedKeys = res.checkedKeys;
          checkedKeys.forEach((v) => {
            nextTick(() => {
              menuRef.value.setChecked(v, true, false);
            });
          });
        });
      });
    });
    title.value = "修改角色";
  }

  /** 根据角色ID查询菜单树结构 */
  function getRoleMenuTreeselect(roleId) {
    return roleMenuTreeselect(roleId).then(response => {
      menuOptions.value = response.menus;
      return response;
    });
  }

  /** 根据角色ID查询部门树结构 */
  function getDeptTree(roleId) {
    return deptTreeSelect(roleId).then(response => {
      deptOptions.value = response.depts;
      return response;
    });
  }

  /** 树权限（展开/折叠）*/
  function handleCheckedTreeExpand(value, type) {
    if (type == "menu") {
      let treeList = menuOptions.value;
      for (let i = 0; i < treeList.length; i++) {
        menuRef.value.store.nodesMap[treeList[i].id].expanded = value;
      }
    } else if (type == "dept") {
      let treeList = deptOptions.value;
      for (let i = 0; i < treeList.length; i++) {
        deptRef.value.store.nodesMap[treeList[i].id].expanded = value;
      }
    }
  }

  /** 树权限（全选/全不选） */
  function handleCheckedTreeNodeAll(value, type) {
    if (type == "menu") {
      menuRef.value.setCheckedNodes(value ? menuOptions.value : []);
    } else if (type == "dept") {
      deptRef.value.setCheckedNodes(value ? deptOptions.value : []);
    }
  }

  /** 树权限（父子联动） */
  function handleCheckedTreeConnect(value, type) {
    if (type == "menu") {
      form.value.menuCheckStrictly = value ? true : false;
    } else if (type == "dept") {
      form.value.deptCheckStrictly = value ? true : false;
    }
  }

  /** 所有菜单节点数据 */
  function getMenuAllCheckedKeys() {
    // 目前被选中的菜单节点
    let checkedKeys = menuRef.value.getCheckedKeys();
    // 半选中的菜单节点
    let halfCheckedKeys = menuRef.value.getHalfCheckedKeys();
    checkedKeys.unshift.apply(checkedKeys, halfCheckedKeys);
    return checkedKeys;
  }

  /** 提交按钮 */
  function submitForm() {
    proxy.$refs["roleRef"].validate(valid => {
      if (valid) {
        if (form.value.roleId != undefined) {
          form.value.menuIds = getMenuAllCheckedKeys();
          updateRole(form.value).then(response => {
            proxy.$modal.msgSuccess("修改成功");
            open.value = false;
            getList();
          });
        } else {
          form.value.menuIds = getMenuAllCheckedKeys();
          addRole(form.value).then(response => {
            proxy.$modal.msgSuccess("新增成功");
            open.value = false;
            getList();
          });
        }
      }
    });
  }

  /** 取消按钮 */
  function cancel() {
    open.value = false;
    reset();
  }

  /** 选择角色权限范围触发 */
  function dataScopeSelectChange(value) {
    if (value !== "2") {
      deptRef.value.setCheckedKeys([]);
    }
  }

  /** 分配数据权限操作 */
  function handleDataScope(row) {
    reset();
    const deptTreeSelect = getDeptTree(row.roleId);
    getRole(row.roleId).then(response => {
      form.value = response.data;
      openDataScope.value = true;
      nextTick(() => {
        deptTreeSelect.then(res => {
          nextTick(() => {
            if (deptRef.value) {
              deptRef.value.setCheckedKeys(res.checkedKeys);
            }
          });
        });
      });
    });
    title.value = "分配数据权限";
  }

  /** 提交按钮（数据权限） */
  function submitDataScope() {
    if (form.value.roleId != undefined) {
      form.value.deptIds = getDeptAllCheckedKeys();
      dataScope(form.value).then(response => {
        proxy.$modal.msgSuccess("修改成功");
        openDataScope.value = false;
        getList();
      });
    }
  }

  /** 取消按钮（数据权限）*/
  function cancelDataScope() {
    openDataScope.value = false;
    reset();
  }

  getList();
</script>
<style scoped
  lang="scss">
  .el-tree {
    height: 310px;
    overflow-y: scroll;

    /* 灰色滚动条背景 */
    &::-webkit-scrollbar-track {
      background-color: transparent;
    }
  }
</style>